function  [y] = UGM_Decode_Block_ICM(nodePot, edgePot, edgeStruct, infoStruct, blocks, decodeFunc)
% INPUT
% nodePot(node,class)
% edgePot(class,class,edge) where e is referenced by V,E (must be the same
% between feature engine and inference engine)
%
% OUTPUT
% nodeLabel(node)

[nNodes,maxStates] = size(nodePot);
nEdges = size(edgePot,3);
edgeEnds = edgeStruct.edgeEnds;
V = edgeStruct.V;
E = edgeStruct.E;
nStates = infoStruct.nStates;

% Initialize
nBlocks = length(blocks);
[junk y] = max(nodePot,[],2);

done = 0;
while ~done
    done = 1;
    for b = 1:nBlocks
        clamped = y;
        clamped(blocks{b}) = 0;
        
      [clampedNP,clampedEP,clampedES,clampedIS] = UGM_makeClampedPotentials(nodePot, edgePot, edgeStruct, infoStruct, clamped);
        
      clampedY = decodeFunc(clampedNP,clampedEP,clampedES,clampedIS);
      
      if any(clampedY ~= y(blocks{b}))
          %fprintf('Block Improvement!\n');
          y(blocks{b}) = clampedY;
          done = 0;
      end
    end

end