function [samples,nodeBel] = UGM_Sample_MF(nodePot,edgePot,edgeStruct,infoStruct)
% Generate Samples from the variational Mean Field model

nodeBel = UGM_Infer_MF(nodePot,edgePot,edgeStruct,infoStruct);

[nNodes,maxStates] = size(nodePot);
nStates = infoStruct.nStates;
maxIter = infoStruct.maxIter;

samples = zeros(nNodes,0);
for i = 1:maxIter
    for n = 1:nNodes
        % Sample State;
        y(n) = sampleDiscrete(nodeBel(n,1:nStates(n)));
    end
    samples(:,i) = y;
end